uses
  dos, crt;


const
  frei : String[04] = 'Frei';
  BDB1 : String[20] = 'BLACKY-DATEN-BANK-1';


var                   {255}
  Datensatze: array[1..200] of String;
  Name: String;
  SuchStr, datei, cd, FeldNamen: String;
  I: Integer;
  Ge: Boolean;
  Akt: Byte;


function Gross(a: String): String;
var
  i: Byte;
begin
  for i := 1 to Length(a) do
      a[i] := UpCase(a[i]);
  Gross := a;
end;


procedure conOA(B: Boolean; var s : String);
begin
  for i := 1 to Length(s) + 1 do
      begin
        if B then
           begin
             {Eszet =  > 223 = } if s[i] = '' then s[i] := '';
             {kl.eu =  > 252 = } if s[i] = '' then s[i] := '';
             {gr.eu =  > 220 = } if s[i] = '' then s[i] := '';
             {kl.ea =  > 228 = } if s[i] = '' then s[i] := '';
             {gr.ea =  > 196 = } if s[i] = '' then s[i] := '';
             {kl.eo =  > 246 = } if s[i] = '' then s[i] := '';
             {gr.eo =  > 201 = } if s[i] = '' then s[i] := '';
           end
        else
           begin
             {Eszet =  > 223 = } if s[i] = '' then s[i] := '';
             {kl.eu =  > 252 = } if s[i] = '' then s[i] := '';
             {gr.eu =  > 220 = } if s[i] = '' then s[i] := '';
             {kl.ea =  > 228 = } if s[i] = '' then s[i] := '';
             {gr.ea =  > 196 = } if s[i] = '' then s[i] := '';
             {kl.eo =  > 246 = } if s[i] = '' then s[i] := '';
             {gr.eo =  > 201 = } if s[i] = '' then s[i] := '';
           end;
      end;
end;


procedure ConvertOtA(B: Boolean);  {Windows nach DOS = True; DOS nach Windows = False}
var
  i2: Integer;
  s: String;
begin
  for i2 := 1 to 200 do
      begin
        s := DatenSatze[i2];
        conOA(B, s);
        DatenSatze[i2] := s;
      end;
end;


function load(ldatei: String): Boolean;
var
  F: Text;
begin
  load := True;
  if ldatei = '' then
     begin
       load := False;
       exit;
     end;
  Assign(F, ldatei);
  {$I-}
  reset(F);
  if IOResult = 0 then
     begin
       ReadLn(F, cd);
       if gross(cd) = BDB1 then
          begin
            ReadLn(F, Name);
            ReadLn(F, FeldNamen);
            conOA(True, Name);
            conOA(True, FeldNamen);
            for i := 1 to 200 do
                begin
                  ReadLn(F, DatenSatze[i]);
                  if pos('', DatenSatze[i]) <> 0 then
                     begin
                       DatenSatze[i] := Frei;
                       i := 200;
                       ReadLn(F);
                       ReadLn(F);
                       ReadLn(F);
                       ReadLn(F);
                       ReadLn(F);
                     end;
                  if EOF(F) then i := 200;
                end;
            if NOT EOF(F) then
               begin
                 WriteLn('ACHTUNG: Die Datenbank ist zu gro. Wurde nicht ganz geladen.');
                 ReadLn;
               end;
            datei := ldatei;
          end
       else
          load := False;
     end
  else
     load := False;
  ConvertOtA(True);
  close(F);
  if IOResult <> 0 then datei := datei;
end;


function GetDatenSatz(DatenSatz: String; Feld: Byte): String;
var
  StZ, EnZ: Char;
begin
  StZ := Chr(Feld);
  EnZ := Chr(Feld + 1);
  if Feld = 8 then EnZ := Chr(11);
  GetDatenSatz := copy(DatenSatz, (pos(StZ, DatenSatz) +
                  Length(StZ)), (pos(EnZ, DatenSatz) -
                  (pos(StZ, DatenSatz) + Length(StZ))));
end;


function GetPathName(Dir2: String): String;
var
  path: DirStr;
  name: NameStr;
  suffix: ExtStr;
begin
  FSplit(dir2, path, name, suffix);
  GetPathName := path + name;
end;


procedure BSK(Datei: String);
var
  X, F, DF: File;
  xy: Boolean;
begin
  Assign(f, Datei);
  {$I-}
  Reset(f);
  {$I+}
  if IOResult = 0 then
     begin
       close(f);
       cd := GetPathName(Datei) + '.BSK';
       Assign(DF, cd);
       {$I-}
       erase(DF);
       {$I+}
       xy := IOResult = 0;
       Assign(x, Datei);
       {$I-}
       Rename(x, cd);
       {$I+}
       xy := IOResult = 0;
     end;
end;


procedure Save;
var
  F: Text;
begin
  BSK(datei);
  Assign(F, datei);
  rewrite(F);
  WriteLn(F, BDB1);
  conOA(False, Name);
  conOA(False, FeldNamen);
  WriteLn(F, Name);
  WriteLn(F, FeldNamen);
  ConvertOtA(False);
  for i := 1 to 200 do
      begin
        if DatenSatze[i] <> Frei then
           WriteLn(F, DatenSatze[i]);
      end;
  WriteLn(F, '');
  Write(F, #26);
  close(F);
  Ge := False;
  ConvertOtA(True);
  conOA(True, Name);
  conOA(True, FeldNamen);
end;


procedure paint(var w: Byte);
var
  i, b: Byte;
begin
  b := 1;
  for i := 1 to 8 do
      if Length(GetDatenSatz(FeldNamen, i)) > b then
         b := Length(GetDatenSatz(FeldNamen, i));
  if b > 25 then b := 25;
  GoToXY(1, 1);
  TextColor(7);
  Write('ͻ');
  Write(' Blacky Daten Bank (c) Copyright by Andreas Hofmeier Computer Programme       ');
  Write('͹');
  Write(' Datenbank:                                                                   ');
  Write(' Name     :                                                                   ');
  Write('͹');
  Write(' ESC = Exit  -- = DS Auwahl  F2 = Save  F4 = Save As  F3 = Suche        ');
  Write(' N = Name    B = Feldnamen E  INS = Neu  ENTER = Edit  DEL = Lschen     ');
  Write('                                                                              ');
  Write('͹');
  Write('                                                                              ');
  Write('                                                                              ');
  Write('                                                                              ');
  Write('                                                                              ');
  Write('                                                                              ');
  Write('                                                                              ');
  Write('                                                                              ');
  Write('                                                                              ');
  Write('͹');
  Write('                                                                              ');
  Write('                                                                              ');
  Write('͹');
  Write(' COMMAND ->                                                                   ');
  Write('ͼ');
  for i := 1 to 8 do
      begin
        GoToXY(3, 10 + i);
        Write(copy(GetDatenSatz(FeldNamen, i) + '                                             ', 1, b), ':');
      end;
  for i := 1 to 8 do
      begin
        GoToXY(b + 5, 10 + i);
        Write(copy(GetDatenSatz(DatenSatze[w], i), 1, 60 - b));
      end;
  GoToXY(16, 7);
  Write(#24#25);
  GoToXY(5, 19);
  Write(w);
  if Ge then
     begin
       GoToXY(3, 19);
       Write(#15);
     end;
  GoToXY(14, 4);
  Write(datei);
  GoToXY(14, 5);
  Write(Name);
  GoToXY(14, 23);
end;


function Eingabe(Was: String): String;
var
  i: Byte;
begin
  GoToXY(3, 20);
  TextColor(15);
  WriteLn(Was);
  GoToXY(3, 21);
  ReadLn(cd);
  for i := 1 to Length(cd) do
      if Ord(cd[i]) < 32 then cd[i] := 'x';
  Eingabe := CD;
  paint(Akt);
end;


var
  sizl: Char;
  b: Byte;
  x: Text;
  a: Boolean;
begin
  Randomize;
  SuchStr := '';
  Akt := 1;
  Ge := False;
  for i := 1 to 200 do
      DatenSatze[i] := Frei;
  if ParamStr(1) <> '' then
     begin
       a := false;
       Assign(x, ParamStr(1));
       {$I-}
       reset(x);
       if IOResult = 0 then
          begin
            close(x);
            a := Load(ParamStr(1));
          end
       else
          begin
            Assign(x, ParamStr(1) + '.BDB');
            reset(x);
            if IOResult = 0 then
               begin
                 close(x);
                 a := Load(ParamStr(1) + '.BDB');
               end;
          end;
       if NOT a then
          begin
            WriteLn('Datei nicht gefunden: ', ParamStr(1));
            ReadLn;
          end;
     end
  else
     begin
       WriteLn('Help');
       WriteLn('  D_BDB <datenbank>');
       ReadLn;
     end;
  paint(Akt);
  repeat
    if KeyPressed then
    begin
       if KeyPressed then
          begin
            GoToXY(14, 23);
            Write(Port[$60]);
            cd := ReadKey;
            if Port[$60] > 70 then cd := ReadKey;
            case Port[$60] of
              {Beenden}
              1 :
                begin
                  if Ge then
                     begin
                       cd := Eingabe('ACHTUNG: Die geladene Datenbank ist nicht gespeichert. Speichern? (Y/N/A)');
                       if UpCase(cd[1]) in ['J', 'Y'] then
                          begin
                            Save;
                            ClrScr;
                            Halt;
                          end;
                       if UpCase(cd[1]) = 'N' then
                          begin
                            ClrScr;
                            Halt;
                          end;
                     end
                  else
                     begin
                       ClrScr;
                       Halt;
                     end;
                end;
              {Datensatz Editieren}
              28:
                begin
                  for i := 1 to 8 do
                      begin
                        TextColor(15);
                        GoToXY(2, 10 + i);
                        Write(i);
                      end;
                  cd := Eingabe('Welches Datenfeld mchten Sie ndern? (1-8)');
                  Val(cd[1], b, I);
                  if (b > 0) and (b < 9) then
                     begin
                       cd := '';
                       for i := 1 to 8 do
                           begin
                             if i = b then
                                cd := cd + Eingabe('ENTER ' + GetDatenSatz(FeldNamen, b) + ' :')
                             else
                                cd := cd + GetDatenSatz(DatenSatze[Akt], i);
                             if i = 8 then
                                cd := cd + ''
                             else
                                cd := cd + Chr(i + 1);
                           end;
                       DatenSatze[Akt] := cd;
                       Ge := True;
                       paint(Akt);
                     end;
                end;
              {FeldNamen Editieren}
              48:
                begin
                  for i := 1 to 8 do
                      begin
                        TextColor(15);
                        GoToXY(2, 10 + i);
                        Write(i);
                      end;
                  cd := FeldNamen;
                  sizl := '1';
                  if cd[Length(cd)] <> '' then
                     sizl := cd[Length(cd)];
                  cd := Eingabe('Welchen FeldNamen mchten Sie ndern? (1-8)');
                  Val(cd[1], b, I);
                  if (b > 0) and (b < 9) then
                     begin
                       cd := '';
                       for i := 1 to 8 do
                           begin
                             if i = b then
                                cd := cd + Eingabe('Ersetze "' + GetDatenSatz(FeldNamen, b) + '" durch :')
                             else
                                cd := cd + GetDatenSatz(FeldNamen, i);
                             if i = 8 then
                                cd := cd + '' + sizl
                             else
                                cd := cd + Chr(i + 1);
                           end;
                       FeldNamen := cd;
                       Ge := True;
                       paint(Akt);
                     end;
                end;
              {Speichern}
              60:
                begin
                  Save;
                  paint(Akt);
                end;
              {Suchen}
              61:
                begin
                  cd := Eingabe('Suche String. ("" fr "' + SuchStr + '" weitersuchen.)');
                  if cd <> '' then
                     begin
                       SuchStr := cd;
                       for i := 1 to 200 do
                           if Pos(Gross(SuchStr), Gross(DatenSatze[i])) <> 0 then
                              begin
                                Akt := I;
                                I := 200;
                              end;
                     end
                  else
                     begin
                       if SuchStr <> '' then
                          begin
                            for i := (Akt + 1) to 200 do
                                if Pos(Gross(SuchStr), Gross(DatenSatze[i])) <> 0 then
                                   begin
                                     Akt := I;
                                     I := 200;
                                   end;
                          end;
                     end;
                  paint(Akt);
                end;
              {Speichern Unter}
              62:
                begin
                  cd := Eingabe('Geladene Datenbank Speichern Unter ("" fr Abbrechen): ');
                  if cd <> '' then
                     begin
                       if cd[Length(cd) - 3] <> '.' then
                          if cd[Length(cd)] <> '.' then
                             cd := cd + '.bdb';
                       datei := cd;
                       Save;
                     end;
                  paint(Akt);
                end;
              {Datensatz Plus}
              72:
                begin
                  I := 0;
                  Akt := Akt + 1;
                  if DatenSatze[Akt] = Frei then
                  repeat
                    Akt := Akt + 1;
                    if Akt > 200 then
                       begin
                         if I = 1 then BREAK;
                         Akt := 1;
                         I := 1;
                       end;
                  until DatenSatze[Akt] <> Frei;
                  paint(Akt);
                end;
              {Datensatz Mius}
              80:
                begin
                  Akt := Akt - 1;
                  I := 0;
                  if Akt < 1 then Akt := 200;
                  if DatenSatze[Akt] = Frei then
                  repeat
                    Akt := Akt - 1;
                    if Akt < 1 then
                       begin
                         Akt := 1;
                         if DatenSatze[Akt] = Frei then
                            begin
                              if I = 1 then BREAK;
                              Akt := 200;
                              I := 1;
                            end;
                       end;
                  until DatenSatze[Akt] <> Frei;
                  paint(Akt);
                end;
              {Neuer Datensatz}
              82:
                begin
                  b := 0;
                  for i := 1  to 200 do
                      if DatenSatze[i] = Frei then
                         begin
                           b := i;
                           i := 200;
                         end;
                  if b = 0 then
                     cd := Eingabe('ERROR: Die maximale anzahl von Datenstzen ist erreicht. (200)')
                  else
                     begin
                       cd := '';
                       for i := 1 to 8 do
                           begin
                             cd := cd + Eingabe('Abfrage: ENTER ' + GetDatenSatz(FeldNamen, i) + ' :');
                             if i = 8 then
                                cd := cd + ''
                             else
                                cd := cd + Chr(i + 1);
                           end;
                       Akt := b;
                       DatenSatze[Akt] := cd;
                       Ge := True;
                       paint(Akt);
                     end;
                end;
              {Datensatz Lschen}
              83:
                begin
                  paint(Akt);
                  cd := Eingabe('Sind Sie sicher das Sie den Aktuellen Datensatz Lschen wollen? (Y/N).');
                  if UpCase(cd[1]) in ['Y', 'J'] then
                     begin
                       DatenSatze[Akt] := Frei;
                       Ge := True;
                     end;
                  paint(Akt);
                end;
              {Datenbanknamen ndern}
              49:
                begin
                  cd := Eingabe('Geben Sie den neuen Namen der Datenbank ein. "" fr den alten.');
                  if cd <> '' then
                     begin
                       Name := cd;
                       ge := True;
                     end;
                  paint(Akt);
                end;
            end;  {end case}
          end;
    end;
  until False;
  {
   GoToXY(50, 5);
   X := von Rechtz
   Y := von Links
  }
end.
